<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
<meta http-equiv="X-UA-Compatible" content="IE=9"/>
<meta name="generator" content="Doxygen 1.8.9.1"/>
<title>Flair: UavStateMachine.h Source File</title>
<link href="tabs.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="jquery.js"></script>
<script type="text/javascript" src="dynsections.js"></script>
<link href="navtree.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="resize.js"></script>
<script type="text/javascript" src="navtreedata.js"></script>
<script type="text/javascript" src="navtree.js"></script>
<script type="text/javascript">
  $(document).ready(initResizable);
  $(window).load(resizeHeight);
</script>
<link href="search/search.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="search/searchdata.js"></script>
<script type="text/javascript" src="search/search.js"></script>
<script type="text/javascript">
  $(document).ready(function() { init_search(); });
</script>
<link href="doxygen.css" rel="stylesheet" type="text/css" />
</head>
<body>
<div id="top"><!-- do not remove this div, it is closed by doxygen! -->
<div id="titlearea">
<table cellspacing="0" cellpadding="0">
 <tbody>
 <tr style="height: 56px;">
  <td id="projectlogo"><img alt="Logo" src="logo_hds.png"/></td>
  <td style="padding-left: 0.5em;">
   <div id="projectname">Flair
   </div>
   <div id="projectbrief">Framework Libre Air</div>
  </td>
 </tr>
 </tbody>
</table>
</div>
<!-- end header part -->
<!-- Generated by Doxygen 1.8.9.1 -->
<script type="text/javascript">
var searchBox = new SearchBox("searchBox", "search",false,'Search');
</script>
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.html"><span>Main&#160;Page</span></a></li>
      <li><a href="namespaces.html"><span>Namespaces</span></a></li>
      <li><a href="annotated.html"><span>Classes</span></a></li>
      <li class="current"><a href="files.html"><span>Files</span></a></li>
      <li>
        <div id="MSearchBox" class="MSearchBoxInactive">
        <span class="left">
          <img id="MSearchSelect" src="search/mag_sel.png"
               onmouseover="return searchBox.OnSearchSelectShow()"
               onmouseout="return searchBox.OnSearchSelectHide()"
               alt=""/>
          <input type="text" id="MSearchField" value="Search" accesskey="S"
               onfocus="searchBox.OnSearchFieldFocus(true)" 
               onblur="searchBox.OnSearchFieldFocus(false)" 
               onkeyup="searchBox.OnSearchFieldChange(event)"/>
          </span><span class="right">
            <a id="MSearchClose" href="javascript:searchBox.CloseResultsWindow()"><img id="MSearchCloseImg" border="0" src="search/close.png" alt=""/></a>
          </span>
        </div>
      </li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="files.html"><span>File&#160;List</span></a></li>
    </ul>
  </div>
</div><!-- top -->
<div id="side-nav" class="ui-resizable side-nav-resizable">
  <div id="nav-tree">
    <div id="nav-tree-contents">
      <div id="nav-sync" class="sync"></div>
    </div>
  </div>
  <div id="splitbar" style="-moz-user-select:none;" 
       class="ui-resizable-handle">
  </div>
</div>
<script type="text/javascript">
$(document).ready(function(){initNavTree('_uav_state_machine_8h_source.html','');});
</script>
<div id="doc-content">
<!-- window showing the filter options -->
<div id="MSearchSelectWindow"
     onmouseover="return searchBox.OnSearchSelectShow()"
     onmouseout="return searchBox.OnSearchSelectHide()"
     onkeydown="return searchBox.OnSearchSelectKey(event)">
</div>

<!-- iframe showing the search results (closed by default) -->
<div id="MSearchResultsWindow">
<iframe src="javascript:void(0)" frameborder="0" 
        name="MSearchResults" id="MSearchResults">
</iframe>
</div>

<div class="header">
  <div class="headertitle">
<div class="title">UavStateMachine.h</div>  </div>
</div><!--header-->
<div class="contents">
<div class="fragment"><div class="line"><a name="l00001"></a><span class="lineno">    1</span>&#160;<span class="comment">// %flair:license{</span></div>
<div class="line"><a name="l00002"></a><span class="lineno">    2</span>&#160;<span class="comment">// This file is part of the Flair framework distributed under the</span></div>
<div class="line"><a name="l00003"></a><span class="lineno">    3</span>&#160;<span class="comment">// CECILL-C License, Version 1.0.</span></div>
<div class="line"><a name="l00004"></a><span class="lineno">    4</span>&#160;<span class="comment">// %flair:license}</span></div>
<div class="line"><a name="l00005"></a><span class="lineno">    5</span>&#160;<span class="comment">//  created:    2014/04/29</span></div>
<div class="line"><a name="l00006"></a><span class="lineno">    6</span>&#160;<span class="comment">//  filename:   UavStateMachine.h</span></div>
<div class="line"><a name="l00007"></a><span class="lineno">    7</span>&#160;<span class="comment">//</span></div>
<div class="line"><a name="l00008"></a><span class="lineno">    8</span>&#160;<span class="comment">//  author:     Gildas Bayard, Guillaume Sanahuja</span></div>
<div class="line"><a name="l00009"></a><span class="lineno">    9</span>&#160;<span class="comment">//              Copyright Heudiasyc UMR UTC/CNRS 7253</span></div>
<div class="line"><a name="l00010"></a><span class="lineno">   10</span>&#160;<span class="comment">//</span></div>
<div class="line"><a name="l00011"></a><span class="lineno">   11</span>&#160;<span class="comment">//  version:    $Id: $</span></div>
<div class="line"><a name="l00012"></a><span class="lineno">   12</span>&#160;<span class="comment">//</span></div>
<div class="line"><a name="l00013"></a><span class="lineno">   13</span>&#160;<span class="comment">//  purpose:    state machine for UAV</span></div>
<div class="line"><a name="l00014"></a><span class="lineno">   14</span>&#160;<span class="comment">//</span></div>
<div class="line"><a name="l00015"></a><span class="lineno">   15</span>&#160;<span class="comment">//</span></div>
<div class="line"><a name="l00016"></a><span class="lineno">   16</span>&#160;<span class="comment">/*********************************************************************/</span></div>
<div class="line"><a name="l00017"></a><span class="lineno">   17</span>&#160;</div>
<div class="line"><a name="l00018"></a><span class="lineno">   18</span>&#160;<span class="preprocessor">#ifndef UAVSTATEMACHINE_H</span></div>
<div class="line"><a name="l00019"></a><span class="lineno">   19</span>&#160;<span class="preprocessor">#define UAVSTATEMACHINE_H</span></div>
<div class="line"><a name="l00020"></a><span class="lineno">   20</span>&#160;</div>
<div class="line"><a name="l00021"></a><span class="lineno">   21</span>&#160;<span class="preprocessor">#include &lt;<a class="code" href="_thread_8h.html">Thread.h</a>&gt;</span></div>
<div class="line"><a name="l00022"></a><span class="lineno">   22</span>&#160;<span class="preprocessor">#include &lt;<a class="code" href="_vector2_d_8h.html">Vector2D.h</a>&gt;</span></div>
<div class="line"><a name="l00023"></a><span class="lineno">   23</span>&#160;<span class="preprocessor">#include &lt;<a class="code" href="_vector3_d_8h.html">Vector3D.h</a>&gt;</span></div>
<div class="line"><a name="l00024"></a><span class="lineno">   24</span>&#160;<span class="preprocessor">#include &lt;<a class="code" href="_euler_8h.html">Euler.h</a>&gt;</span></div>
<div class="line"><a name="l00025"></a><span class="lineno">   25</span>&#160;<span class="preprocessor">#include &lt;<a class="code" href="_quaternion_8h.html">Quaternion.h</a>&gt;</span></div>
<div class="line"><a name="l00026"></a><span class="lineno">   26</span>&#160;</div>
<div class="line"><a name="l00027"></a><span class="lineno">   27</span>&#160;<span class="keyword">namespace </span><a class="code" href="namespaceflair.html">flair</a> {</div>
<div class="line"><a name="l00028"></a><span class="lineno">   28</span>&#160;<span class="keyword">namespace </span>core {</div>
<div class="line"><a name="l00029"></a><span class="lineno">   29</span>&#160;<span class="keyword">class </span>FrameworkManager;</div>
<div class="line"><a name="l00030"></a><span class="lineno">   30</span>&#160;<span class="keyword">class </span>AhrsData;</div>
<div class="line"><a name="l00031"></a><span class="lineno">   31</span>&#160;<span class="keyword">class </span>io_data;</div>
<div class="line"><a name="l00032"></a><span class="lineno">   32</span>&#160;}</div>
<div class="line"><a name="l00033"></a><span class="lineno">   33</span>&#160;<span class="keyword">namespace </span>gui {</div>
<div class="line"><a name="l00034"></a><span class="lineno">   34</span>&#160;<span class="keyword">class </span>PushButton;</div>
<div class="line"><a name="l00035"></a><span class="lineno">   35</span>&#160;<span class="keyword">class </span>GridLayout;</div>
<div class="line"><a name="l00036"></a><span class="lineno">   36</span>&#160;<span class="keyword">class </span>Tab;</div>
<div class="line"><a name="l00037"></a><span class="lineno">   37</span>&#160;<span class="keyword">class </span>DoubleSpinBox;</div>
<div class="line"><a name="l00038"></a><span class="lineno">   38</span>&#160;}</div>
<div class="line"><a name="l00039"></a><span class="lineno">   39</span>&#160;<span class="keyword">namespace </span>filter {</div>
<div class="line"><a name="l00040"></a><span class="lineno">   40</span>&#160;<span class="keyword">class </span>ControlLaw;</div>
<div class="line"><a name="l00041"></a><span class="lineno">   41</span>&#160;<span class="keyword">class </span>NestedSat;</div>
<div class="line"><a name="l00042"></a><span class="lineno">   42</span>&#160;<span class="keyword">class </span>Pid;</div>
<div class="line"><a name="l00043"></a><span class="lineno">   43</span>&#160;<span class="keyword">class </span>PidThrust;</div>
<div class="line"><a name="l00044"></a><span class="lineno">   44</span>&#160;<span class="keyword">class </span>TrajectoryGenerator1D;</div>
<div class="line"><a name="l00045"></a><span class="lineno">   45</span>&#160;}</div>
<div class="line"><a name="l00046"></a><span class="lineno">   46</span>&#160;<span class="keyword">namespace </span>sensor {</div>
<div class="line"><a name="l00047"></a><span class="lineno">   47</span>&#160;<span class="keyword">class </span>TargetController;</div>
<div class="line"><a name="l00048"></a><span class="lineno">   48</span>&#160;}</div>
<div class="line"><a name="l00049"></a><span class="lineno">   49</span>&#160;<span class="keyword">namespace </span>meta {</div>
<div class="line"><a name="l00050"></a><span class="lineno">   50</span>&#160;<span class="keyword">class </span>MetaDualShock3;</div>
<div class="line"><a name="l00051"></a><span class="lineno">   51</span>&#160;<span class="keyword">class </span>Uav;</div>
<div class="line"><a name="l00052"></a><span class="lineno">   52</span>&#160;}</div>
<div class="line"><a name="l00053"></a><span class="lineno">   53</span>&#160;}</div>
<div class="line"><a name="l00054"></a><span class="lineno">   54</span>&#160;</div>
<div class="line"><a name="l00055"></a><span class="lineno">   55</span>&#160;<span class="keyword">namespace </span><a class="code" href="namespaceflair.html">flair</a> {</div>
<div class="line"><a name="l00056"></a><span class="lineno">   56</span>&#160;<span class="keyword">namespace </span>meta {</div>
<div class="line"><a name="l00057"></a><span class="lineno">   57</span>&#160;</div>
<div class="line"><a name="l00067"></a><span class="lineno"><a class="line" href="classflair_1_1meta_1_1_uav_state_machine.html">   67</a></span>&#160;<span class="keyword">class </span><a class="code" href="classflair_1_1meta_1_1_uav_state_machine.html">UavStateMachine</a> : <span class="keyword">public</span> <a class="code" href="classflair_1_1core_1_1_thread.html">core::Thread</a> {</div>
<div class="line"><a name="l00068"></a><span class="lineno">   68</span>&#160;<span class="keyword">protected</span>:</div>
<div class="line"><a name="l00069"></a><span class="lineno">   69</span>&#160;  <span class="keyword">enum class</span> AltitudeMode_t { Manual, Custom };</div>
<div class="line"><a name="l00070"></a><span class="lineno">   70</span>&#160;  <span class="keyword">const</span> AltitudeMode_t &amp;GetAltitudeMode(<span class="keywordtype">void</span>)<span class="keyword"> const </span>{ <span class="keywordflow">return</span> altitudeMode; }</div>
<div class="line"><a name="l00071"></a><span class="lineno">   71</span>&#160;  <span class="keywordtype">bool</span> SetAltitudeMode(<span class="keyword">const</span> AltitudeMode_t &amp;altitudeMode);</div>
<div class="line"><a name="l00072"></a><span class="lineno">   72</span>&#160;</div>
<div class="line"><a name="l00073"></a><span class="lineno">   73</span>&#160;  <span class="comment">// uses TrajectoryGenerator1D *altitudeTrajectory to go to desiredAltitude</span></div>
<div class="line"><a name="l00074"></a><span class="lineno">   74</span>&#160;  <span class="comment">// available in mode AltitudeMode_t::Manual</span></div>
<div class="line"><a name="l00075"></a><span class="lineno">   75</span>&#160;  <span class="comment">// return true if goto is possible</span></div>
<div class="line"><a name="l00076"></a><span class="lineno">   76</span>&#160;  <span class="keywordtype">bool</span> GotoAltitude(<span class="keywordtype">float</span> desiredAltitude);</div>
<div class="line"><a name="l00077"></a><span class="lineno">   77</span>&#160;</div>
<div class="line"><a name="l00078"></a><span class="lineno">   78</span>&#160;  <span class="keyword">enum class</span> OrientationMode_t { Manual, Custom };</div>
<div class="line"><a name="l00079"></a><span class="lineno">   79</span>&#160;  <span class="keyword">const</span> OrientationMode_t &amp;GetOrientationMode(<span class="keywordtype">void</span>)<span class="keyword"> const </span>{</div>
<div class="line"><a name="l00080"></a><span class="lineno">   80</span>&#160;    <span class="keywordflow">return</span> orientationMode;</div>
<div class="line"><a name="l00081"></a><span class="lineno">   81</span>&#160;  }</div>
<div class="line"><a name="l00082"></a><span class="lineno">   82</span>&#160;  <span class="keywordtype">bool</span> SetOrientationMode(<span class="keyword">const</span> OrientationMode_t &amp;orientationMode);</div>
<div class="line"><a name="l00083"></a><span class="lineno">   83</span>&#160;</div>
<div class="line"><a name="l00084"></a><span class="lineno">   84</span>&#160;  <span class="keyword">enum class</span> ThrustMode_t { Default, Custom };</div>
<div class="line"><a name="l00085"></a><span class="lineno">   85</span>&#160;  <span class="keyword">const</span> ThrustMode_t &amp;GetThrustMode()<span class="keyword"> const </span>{ <span class="keywordflow">return</span> thrustMode; }</div>
<div class="line"><a name="l00086"></a><span class="lineno">   86</span>&#160;  <span class="keywordtype">bool</span> SetThrustMode(<span class="keyword">const</span> ThrustMode_t &amp;thrustMode);</div>
<div class="line"><a name="l00087"></a><span class="lineno">   87</span>&#160;</div>
<div class="line"><a name="l00088"></a><span class="lineno">   88</span>&#160;  <span class="keyword">enum class</span> TorqueMode_t { Default, Custom };</div>
<div class="line"><a name="l00089"></a><span class="lineno">   89</span>&#160;  <span class="keyword">const</span> TorqueMode_t &amp;GetTorqueMode(<span class="keywordtype">void</span>)<span class="keyword"> const </span>{ <span class="keywordflow">return</span> torqueMode; }</div>
<div class="line"><a name="l00090"></a><span class="lineno">   90</span>&#160;  <span class="keywordtype">bool</span> SetTorqueMode(<span class="keyword">const</span> TorqueMode_t &amp;torqueMode);</div>
<div class="line"><a name="l00091"></a><span class="lineno">   91</span>&#160;</div>
<div class="line"><a name="l00092"></a><span class="lineno">   92</span>&#160;  <span class="keyword">enum class</span> Event_t {</div>
<div class="line"><a name="l00093"></a><span class="lineno">   93</span>&#160;    EnteringFailSafeMode,</div>
<div class="line"><a name="l00094"></a><span class="lineno">   94</span>&#160;    EnteringControlLoop,</div>
<div class="line"><a name="l00095"></a><span class="lineno">   95</span>&#160;    StartLanding,</div>
<div class="line"><a name="l00096"></a><span class="lineno">   96</span>&#160;    FinishLanding,</div>
<div class="line"><a name="l00097"></a><span class="lineno">   97</span>&#160;    Stopped,</div>
<div class="line"><a name="l00098"></a><span class="lineno">   98</span>&#160;    TakingOff,</div>
<div class="line"><a name="l00099"></a><span class="lineno">   99</span>&#160;    EmergencyStop,</div>
<div class="line"><a name="l00100"></a><span class="lineno">  100</span>&#160;    Stabilized, <span class="comment">// as soon as uav is 3cm far from the ground</span></div>
<div class="line"><a name="l00101"></a><span class="lineno">  101</span>&#160;    ZTrajectoryFinished,</div>
<div class="line"><a name="l00102"></a><span class="lineno">  102</span>&#160;  };</div>
<div class="line"><a name="l00103"></a><span class="lineno">  103</span>&#160;</div>
<div class="line"><a name="l00104"></a><span class="lineno">  104</span>&#160;        <a class="code" href="classflair_1_1meta_1_1_uav_state_machine.html">UavStateMachine</a>(<a class="code" href="classflair_1_1sensor_1_1_target_controller.html">sensor::TargetController</a>* controller);</div>
<div class="line"><a name="l00105"></a><span class="lineno">  105</span>&#160;        ~<a class="code" href="classflair_1_1meta_1_1_uav_state_machine.html">UavStateMachine</a>();</div>
<div class="line"><a name="l00106"></a><span class="lineno">  106</span>&#160;</div>
<div class="line"><a name="l00107"></a><span class="lineno">  107</span>&#160;  <span class="keyword">const</span> <a class="code" href="classflair_1_1core_1_1_quaternion.html">core::Quaternion</a> &amp;GetCurrentQuaternion(<span class="keywordtype">void</span>) <span class="keyword">const</span>;</div>
<div class="line"><a name="l00108"></a><span class="lineno">  108</span>&#160;</div>
<div class="line"><a name="l00109"></a><span class="lineno">  109</span>&#160;  <span class="keyword">const</span> <a class="code" href="classflair_1_1core_1_1_vector3_d.html">core::Vector3Df</a> &amp;GetCurrentAngularSpeed(<span class="keywordtype">void</span>) <span class="keyword">const</span>;</div>
<div class="line"><a name="l00110"></a><span class="lineno">  110</span>&#160;</div>
<div class="line"><a name="l00111"></a><span class="lineno">  111</span>&#160;        <span class="keywordtype">void</span> Land(<span class="keywordtype">void</span>);</div>
<div class="line"><a name="l00112"></a><span class="lineno">  112</span>&#160;        <span class="keywordtype">void</span> EmergencyLand(<span class="keywordtype">void</span>);</div>
<div class="line"><a name="l00113"></a><span class="lineno">  113</span>&#160;        <span class="keywordtype">void</span> TakeOff(<span class="keywordtype">void</span>);</div>
<div class="line"><a name="l00114"></a><span class="lineno">  114</span>&#160;        <span class="keywordtype">void</span> EmergencyStop(<span class="keywordtype">void</span>);</div>
<div class="line"><a name="l00116"></a><span class="lineno">  116</span>&#160;</div>
<div class="line"><a name="l00119"></a><span class="lineno">  119</span>&#160;        <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classflair_1_1meta_1_1_uav_state_machine.html#a734a11e3bbedd8dd1726b2c450353da5">SignalEvent</a>(Event_t event);</div>
<div class="line"><a name="l00120"></a><span class="lineno">  120</span>&#160;</div>
<div class="line"><a name="l00121"></a><span class="lineno">  121</span>&#160;  <span class="keyword">virtual</span> <span class="keyword">const</span> <a class="code" href="classflair_1_1core_1_1_ahrs_data.html">core::AhrsData</a> *GetOrientation(<span class="keywordtype">void</span>) <span class="keyword">const</span>;</div>
<div class="line"><a name="l00122"></a><span class="lineno">  122</span>&#160;  <span class="keyword">const</span> <a class="code" href="classflair_1_1core_1_1_ahrs_data.html">core::AhrsData</a> *GetDefaultOrientation(<span class="keywordtype">void</span>) <span class="keyword">const</span>;</div>
<div class="line"><a name="l00123"></a><span class="lineno">  123</span>&#160;</div>
<div class="line"><a name="l00124"></a><span class="lineno">  124</span>&#160;  <span class="keyword">virtual</span> <span class="keywordtype">void</span> AltitudeValues(<span class="keywordtype">float</span> &amp;z, <span class="keywordtype">float</span> &amp;dz) <span class="keyword">const</span>; <span class="comment">// in uav coordinate!</span></div>
<div class="line"><a name="l00125"></a><span class="lineno">  125</span>&#160;  <span class="keywordtype">void</span> EnterFailSafeMode(<span class="keywordtype">void</span>);</div>
<div class="line"><a name="l00126"></a><span class="lineno">  126</span>&#160;  <span class="keywordtype">bool</span> ExitFailSafeMode(<span class="keywordtype">void</span>);</div>
<div class="line"><a name="l00127"></a><span class="lineno">  127</span>&#160;  <span class="keywordtype">void</span> FailSafeAltitudeValues(<span class="keywordtype">float</span> &amp;z, <span class="keywordtype">float</span> &amp;dz) <span class="keyword">const</span>; <span class="comment">// in uav coordinate!</span></div>
<div class="line"><a name="l00128"></a><span class="lineno">  128</span>&#160;</div>
<div class="line"><a name="l00129"></a><span class="lineno">  129</span>&#160;  <a class="code" href="classflair_1_1gui_1_1_grid_layout.html">gui::GridLayout</a> *GetButtonsLayout(<span class="keywordtype">void</span>) <span class="keyword">const</span>;</div>
<div class="line"><a name="l00130"></a><span class="lineno">  130</span>&#160;  <span class="keyword">virtual</span> <span class="keywordtype">void</span> ExtraSecurityCheck(<span class="keywordtype">void</span>){};</div>
<div class="line"><a name="l00131"></a><span class="lineno">  131</span>&#160;  <span class="keyword">virtual</span> <span class="keywordtype">void</span> ExtraCheckJoystick(<span class="keywordtype">void</span>){};</div>
<div class="line"><a name="l00132"></a><span class="lineno">  132</span>&#160;  <span class="keyword">virtual</span> <span class="keywordtype">void</span> ExtraCheckPushButton(<span class="keywordtype">void</span>){};</div>
<div class="line"><a name="l00133"></a><span class="lineno">  133</span>&#160;</div>
<div class="line"><a name="l00134"></a><span class="lineno">  134</span>&#160;  <span class="keywordtype">void</span> GetDefaultReferenceAltitude(<span class="keywordtype">float</span> &amp;refAltitude,</div>
<div class="line"><a name="l00135"></a><span class="lineno">  135</span>&#160;                                   <span class="keywordtype">float</span> &amp;refVerticalVelocity);</div>
<div class="line"><a name="l00136"></a><span class="lineno">  136</span>&#160;  <span class="keyword">virtual</span> <span class="keywordtype">void</span> GetReferenceAltitude(<span class="keywordtype">float</span> &amp;refAltitude,</div>
<div class="line"><a name="l00137"></a><span class="lineno">  137</span>&#160;                                    <span class="keywordtype">float</span> &amp;refVerticalVelocity);</div>
<div class="line"><a name="l00138"></a><span class="lineno">  138</span>&#160;  <span class="comment">// float GetDefaultThrustOffset(void);</span></div>
<div class="line"><a name="l00139"></a><span class="lineno">  139</span>&#160;  <span class="keyword">const</span> <a class="code" href="classflair_1_1core_1_1_ahrs_data.html">core::AhrsData</a> *GetDefaultReferenceOrientation(<span class="keywordtype">void</span>) <span class="keyword">const</span>;</div>
<div class="line"><a name="l00140"></a><span class="lineno">  140</span>&#160;  <span class="keyword">virtual</span> <span class="keyword">const</span> <a class="code" href="classflair_1_1core_1_1_ahrs_data.html">core::AhrsData</a> *GetReferenceOrientation(<span class="keywordtype">void</span>);</div>
<div class="line"><a name="l00141"></a><span class="lineno">  141</span>&#160;</div>
<div class="line"><a name="l00152"></a><span class="lineno">  152</span>&#160;  <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classflair_1_1meta_1_1_uav_state_machine.html#a239d9f75ff1a46752c2b06c37726336a">ComputeCustomTorques</a>(<a class="code" href="classflair_1_1core_1_1_euler.html">core::Euler</a> &amp;torques);</div>
<div class="line"><a name="l00153"></a><span class="lineno">  153</span>&#160;</div>
<div class="line"><a name="l00164"></a><span class="lineno">  164</span>&#160;  <span class="keywordtype">void</span> <a class="code" href="classflair_1_1meta_1_1_uav_state_machine.html#ac93d0d595a86a014c27375c973f693a8">ComputeDefaultTorques</a>(<a class="code" href="classflair_1_1core_1_1_euler.html">core::Euler</a> &amp;torques);</div>
<div class="line"><a name="l00165"></a><span class="lineno">  165</span>&#160;</div>
<div class="line"><a name="l00171"></a><span class="lineno">  171</span>&#160;  <span class="comment">// const core::Euler &amp;GetTorques() const;</span></div>
<div class="line"><a name="l00172"></a><span class="lineno">  172</span>&#160;</div>
<div class="line"><a name="l00183"></a><span class="lineno">  183</span>&#160;  <span class="keyword">virtual</span> <span class="keywordtype">float</span> <a class="code" href="classflair_1_1meta_1_1_uav_state_machine.html#a6af7f575d90ef500717a999ea4c4afef">ComputeCustomThrust</a>(<span class="keywordtype">void</span>);</div>
<div class="line"><a name="l00184"></a><span class="lineno">  184</span>&#160;</div>
<div class="line"><a name="l00195"></a><span class="lineno">  195</span>&#160;  <span class="keywordtype">float</span> <a class="code" href="classflair_1_1meta_1_1_uav_state_machine.html#ab25472bbf51a7baf97ec5e9cfc148f8b">ComputeDefaultThrust</a>(<span class="keywordtype">void</span>);</div>
<div class="line"><a name="l00196"></a><span class="lineno">  196</span>&#160;</div>
<div class="line"><a name="l00202"></a><span class="lineno">  202</span>&#160;  <span class="comment">// float GetThrust() const;</span></div>
<div class="line"><a name="l00203"></a><span class="lineno">  203</span>&#160;</div>
<div class="line"><a name="l00214"></a><span class="lineno">  214</span>&#160;  <span class="keywordtype">void</span> <a class="code" href="classflair_1_1meta_1_1_uav_state_machine.html#ab737f2861d5c1901a0f62f54fe2c0855">AddDeviceToControlLawLog</a>(<span class="keyword">const</span> <a class="code" href="classflair_1_1core_1_1_i_o_device.html">core::IODevice</a> *device);</div>
<div class="line"><a name="l00215"></a><span class="lineno">  215</span>&#160;</div>
<div class="line"><a name="l00226"></a><span class="lineno">  226</span>&#160;  <span class="keywordtype">void</span> <a class="code" href="classflair_1_1meta_1_1_uav_state_machine.html#aa642bfeb1d97dec839088e2256a3699b">AddDataToControlLawLog</a>(<span class="keyword">const</span> <a class="code" href="classflair_1_1core_1_1io__data.html">core::io_data</a> *data);</div>
<div class="line"><a name="l00227"></a><span class="lineno">  227</span>&#160;</div>
<div class="line"><a name="l00228"></a><span class="lineno">  228</span>&#160;  <span class="keyword">const</span> <a class="code" href="classflair_1_1sensor_1_1_target_controller.html">sensor::TargetController</a> *GetJoystick(<span class="keywordtype">void</span>) <span class="keyword">const</span>;</div>
<div class="line"><a name="l00229"></a><span class="lineno">  229</span>&#160;  <a class="code" href="classflair_1_1meta_1_1_meta_dual_shock3.html">MetaDualShock3</a> *joy;</div>
<div class="line"><a name="l00230"></a><span class="lineno">  230</span>&#160;  </div>
<div class="line"><a name="l00231"></a><span class="lineno">  231</span>&#160;  <a class="code" href="classflair_1_1filter_1_1_nested_sat.html">filter::NestedSat</a> *GetURoll(<span class="keywordtype">void</span>);</div>
<div class="line"><a name="l00232"></a><span class="lineno">  232</span>&#160;  <a class="code" href="classflair_1_1filter_1_1_nested_sat.html">filter::NestedSat</a> *GetUPitch(<span class="keywordtype">void</span>);</div>
<div class="line"><a name="l00233"></a><span class="lineno">  233</span>&#160;  <a class="code" href="classflair_1_1filter_1_1_pid.html">filter::Pid</a> *GetUYaw(<span class="keywordtype">void</span>);</div>
<div class="line"><a name="l00234"></a><span class="lineno">  234</span>&#160;  <a class="code" href="classflair_1_1filter_1_1_pid_thrust.html">filter::PidThrust</a> *GetUZ(<span class="keywordtype">void</span>);</div>
<div class="line"><a name="l00235"></a><span class="lineno">  235</span>&#160;  <a class="code" href="classflair_1_1filter_1_1_trajectory_generator1_d.html">filter::TrajectoryGenerator1D</a> *GetAltitudeTrajectory(<span class="keywordtype">void</span>);</div>
<div class="line"><a name="l00236"></a><span class="lineno">  236</span>&#160;</div>
<div class="line"><a name="l00237"></a><span class="lineno">  237</span>&#160;  <a class="code" href="classflair_1_1gui_1_1_tab.html">gui::Tab</a> *setupLawTab, *graphLawTab;</div>
<div class="line"><a name="l00238"></a><span class="lineno">  238</span>&#160;</div>
<div class="line"><a name="l00239"></a><span class="lineno">  239</span>&#160;<span class="keyword">private</span>:</div>
<div class="line"><a name="l00244"></a><span class="lineno">  244</span>&#160;  <span class="keyword">enum class</span> AltitudeState_t {</div>
<div class="line"><a name="l00245"></a><span class="lineno">  245</span>&#160;    <a class="code" href="classflair_1_1meta_1_1_uav_state_machine.html#a8074514837d84114b8b4e2a6e1d7da86ac23e2b09ebe6bf4cb5e2a9abe85c0be2">Stopped</a>,      </div>
<div class="line"><a name="l00246"></a><span class="lineno">  246</span>&#160;    <a class="code" href="classflair_1_1meta_1_1_uav_state_machine.html#a8074514837d84114b8b4e2a6e1d7da86a85916c5f3400cfa25d988f05b6736a94">TakingOff</a>,    </div>
<div class="line"><a name="l00248"></a><span class="lineno">  248</span>&#160;    <a class="code" href="classflair_1_1meta_1_1_uav_state_machine.html#a8074514837d84114b8b4e2a6e1d7da86afda22026db89cdc5e88b262ad9424b41">Stabilized</a>,   </div>
<div class="line"><a name="l00249"></a><span class="lineno">  249</span>&#160;    <a class="code" href="classflair_1_1meta_1_1_uav_state_machine.html#a8074514837d84114b8b4e2a6e1d7da86a0a0480d215decaf46260e3db52e4dc4c">StartLanding</a>, </div>
<div class="line"><a name="l00251"></a><span class="lineno">  251</span>&#160;    <a class="code" href="classflair_1_1meta_1_1_uav_state_machine.html#a8074514837d84114b8b4e2a6e1d7da86a0912358d703c9a28d93a2707b86161b2">FinishLanding</a> </div>
<div class="line"><a name="l00252"></a><span class="lineno">  252</span>&#160;  };</div>
<div class="line"><a name="l00253"></a><span class="lineno">  253</span>&#160;  AltitudeState_t altitudeState;</div>
<div class="line"><a name="l00254"></a><span class="lineno">  254</span>&#160;  <span class="keywordtype">void</span> ProcessAltitudeFiniteStateMachine();</div>
<div class="line"><a name="l00255"></a><span class="lineno">  255</span>&#160;  <span class="keywordtype">void</span> ComputeReferenceAltitude(<span class="keywordtype">float</span> &amp;refAltitude, <span class="keywordtype">float</span> &amp;refVerticalVelocity);</div>
<div class="line"><a name="l00256"></a><span class="lineno">  256</span>&#160;</div>
<div class="line"><a name="l00257"></a><span class="lineno">  257</span>&#160;  <span class="keywordtype">float</span> groundAltitude; <span class="comment">// effective altitude when the uav leaves the ground</span></div>
<div class="line"><a name="l00258"></a><span class="lineno">  258</span>&#160;  <span class="keywordtype">float</span> currentAltitude, currentVerticalSpeed;</div>
<div class="line"><a name="l00259"></a><span class="lineno">  259</span>&#160;</div>
<div class="line"><a name="l00260"></a><span class="lineno">  260</span>&#160;  <span class="keywordtype">bool</span> failSafeMode;</div>
<div class="line"><a name="l00261"></a><span class="lineno">  261</span>&#160;  <span class="keywordtype">void</span> SecurityCheck(<span class="keywordtype">void</span>);</div>
<div class="line"><a name="l00262"></a><span class="lineno">  262</span>&#160;  <span class="keywordtype">void</span> MandatorySecurityCheck(<span class="keywordtype">void</span>);</div>
<div class="line"><a name="l00263"></a><span class="lineno">  263</span>&#160;  <span class="keywordtype">void</span> CheckJoystick();</div>
<div class="line"><a name="l00264"></a><span class="lineno">  264</span>&#160;  <span class="keywordtype">void</span> GenericCheckJoystick();</div>
<div class="line"><a name="l00265"></a><span class="lineno">  265</span>&#160;  <span class="keywordtype">void</span> CheckPushButton(<span class="keywordtype">void</span>);</div>
<div class="line"><a name="l00266"></a><span class="lineno">  266</span>&#160;  <span class="keywordtype">void</span> GenericCheckPushButton(<span class="keywordtype">void</span>);</div>
<div class="line"><a name="l00267"></a><span class="lineno">  267</span>&#160;  <span class="keywordtype">void</span> Run(<span class="keywordtype">void</span>);</div>
<div class="line"><a name="l00268"></a><span class="lineno">  268</span>&#160;  <span class="keywordtype">void</span> StopMotors(<span class="keywordtype">void</span>);</div>
<div class="line"><a name="l00269"></a><span class="lineno">  269</span>&#160;  <span class="keywordtype">bool</span> IsValuePossible(<span class="keywordtype">float</span> value,std::string desc);</div>
<div class="line"><a name="l00270"></a><span class="lineno">  270</span>&#160;</div>
<div class="line"><a name="l00271"></a><span class="lineno">  271</span>&#160;  <a class="code" href="classflair_1_1meta_1_1_uav.html">meta::Uav</a> *uav;</div>
<div class="line"><a name="l00272"></a><span class="lineno">  272</span>&#160;  <a class="code" href="classflair_1_1sensor_1_1_target_controller.html">sensor::TargetController</a> *controller;</div>
<div class="line"><a name="l00273"></a><span class="lineno">  273</span>&#160;</div>
<div class="line"><a name="l00274"></a><span class="lineno">  274</span>&#160;  <a class="code" href="classflair_1_1core_1_1_quaternion.html">core::Quaternion</a> currentQuaternion;</div>
<div class="line"><a name="l00275"></a><span class="lineno">  275</span>&#160;  <a class="code" href="classflair_1_1core_1_1_vector3_d.html">core::Vector3Df</a> currentAngularSpeed;</div>
<div class="line"><a name="l00276"></a><span class="lineno">  276</span>&#160;</div>
<div class="line"><a name="l00277"></a><span class="lineno">  277</span>&#160;  <span class="keyword">const</span> <a class="code" href="classflair_1_1core_1_1_ahrs_data.html">core::AhrsData</a> *ComputeReferenceOrientation(<span class="keywordtype">void</span>);</div>
<div class="line"><a name="l00278"></a><span class="lineno">  278</span>&#160;</div>
<div class="line"><a name="l00279"></a><span class="lineno">  279</span>&#160;  <span class="keywordtype">void</span> ComputeOrientation(<span class="keywordtype">void</span>);</div>
<div class="line"><a name="l00280"></a><span class="lineno">  280</span>&#160;  <span class="keywordtype">void</span> ComputeAltitude(<span class="keywordtype">void</span>);</div>
<div class="line"><a name="l00281"></a><span class="lineno">  281</span>&#160;</div>
<div class="line"><a name="l00282"></a><span class="lineno">  282</span>&#160;  <span class="keywordtype">void</span> ComputeTorques(<span class="keywordtype">void</span>);</div>
<div class="line"><a name="l00283"></a><span class="lineno">  283</span>&#160;  <a class="code" href="classflair_1_1core_1_1_euler.html">core::Euler</a> currentTorques, savedDefaultTorques;</div>
<div class="line"><a name="l00284"></a><span class="lineno">  284</span>&#160;  <span class="keywordtype">bool</span> needToComputeDefaultTorques;</div>
<div class="line"><a name="l00285"></a><span class="lineno">  285</span>&#160;</div>
<div class="line"><a name="l00286"></a><span class="lineno">  286</span>&#160;  <span class="keywordtype">void</span> ComputeThrust(<span class="keywordtype">void</span>);</div>
<div class="line"><a name="l00287"></a><span class="lineno">  287</span>&#160;  <span class="keywordtype">float</span> currentThrust, savedDefaultThrust;</div>
<div class="line"><a name="l00288"></a><span class="lineno">  288</span>&#160;  <span class="keywordtype">bool</span> needToComputeDefaultThrust;</div>
<div class="line"><a name="l00289"></a><span class="lineno">  289</span>&#160;</div>
<div class="line"><a name="l00290"></a><span class="lineno">  290</span>&#160;  <a class="code" href="classflair_1_1gui_1_1_push_button.html">gui::PushButton</a> *button_kill, *button_take_off, *button_land,</div>
<div class="line"><a name="l00291"></a><span class="lineno">  291</span>&#160;      *button_start_log, *button_stop_log;</div>
<div class="line"><a name="l00292"></a><span class="lineno">  292</span>&#160;  <a class="code" href="classflair_1_1gui_1_1_grid_layout.html">gui::GridLayout</a> *buttonslayout;</div>
<div class="line"><a name="l00293"></a><span class="lineno">  293</span>&#160;  <a class="code" href="classflair_1_1gui_1_1_double_spin_box.html">gui::DoubleSpinBox</a> *desiredTakeoffAltitude, *desiredLandingAltitude;</div>
<div class="line"><a name="l00294"></a><span class="lineno">  294</span>&#160;  AltitudeMode_t altitudeMode;</div>
<div class="line"><a name="l00295"></a><span class="lineno">  295</span>&#160;  OrientationMode_t orientationMode;</div>
<div class="line"><a name="l00296"></a><span class="lineno">  296</span>&#160;  ThrustMode_t thrustMode;</div>
<div class="line"><a name="l00297"></a><span class="lineno">  297</span>&#160;  TorqueMode_t torqueMode;</div>
<div class="line"><a name="l00298"></a><span class="lineno">  298</span>&#160;  <span class="keywordtype">bool</span> flagBatteryLow;</div>
<div class="line"><a name="l00299"></a><span class="lineno">  299</span>&#160;  <span class="keywordtype">bool</span> flagConnectionLost;</div>
<div class="line"><a name="l00300"></a><span class="lineno">  300</span>&#160;  <span class="keywordtype">bool</span> flagCriticalSensorLost;</div>
<div class="line"><a name="l00301"></a><span class="lineno">  301</span>&#160;  <span class="keywordtype">bool</span> flagZTrajectoryFinished;</div>
<div class="line"><a name="l00302"></a><span class="lineno">  302</span>&#160;  <span class="keywordtype">bool</span> safeToFly;</div>
<div class="line"><a name="l00303"></a><span class="lineno">  303</span>&#160;  <a class="code" href="classflair_1_1filter_1_1_nested_sat.html">filter::NestedSat</a> *uRoll, *uPitch;</div>
<div class="line"><a name="l00304"></a><span class="lineno">  304</span>&#160;  <a class="code" href="classflair_1_1filter_1_1_pid.html">filter::Pid</a> *uYaw;</div>
<div class="line"><a name="l00305"></a><span class="lineno">  305</span>&#160;  <a class="code" href="classflair_1_1filter_1_1_pid_thrust.html">filter::PidThrust</a> *uZ;</div>
<div class="line"><a name="l00306"></a><span class="lineno">  306</span>&#160;  <a class="code" href="classflair_1_1filter_1_1_trajectory_generator1_d.html">filter::TrajectoryGenerator1D</a> *altitudeTrajectory;</div>
<div class="line"><a name="l00307"></a><span class="lineno">  307</span>&#160;};</div>
<div class="line"><a name="l00308"></a><span class="lineno">  308</span>&#160;};</div>
<div class="line"><a name="l00309"></a><span class="lineno">  309</span>&#160;};</div>
<div class="line"><a name="l00310"></a><span class="lineno">  310</span>&#160;<span class="preprocessor">#endif // UAVSTATEMACHINE_H</span></div>
<div class="ttc" id="classflair_1_1core_1_1io__data_html"><div class="ttname"><a href="classflair_1_1core_1_1io__data.html">flair::core::io_data</a></div><div class="ttdoc">Abstract class for data types. </div><div class="ttdef"><b>Definition:</b> io_data.h:94</div></div>
<div class="ttc" id="classflair_1_1meta_1_1_uav_state_machine_html_a734a11e3bbedd8dd1726b2c450353da5"><div class="ttname"><a href="classflair_1_1meta_1_1_uav_state_machine.html#a734a11e3bbedd8dd1726b2c450353da5">flair::meta::UavStateMachine::SignalEvent</a></div><div class="ttdeci">virtual void SignalEvent(Event_t event)</div><div class="ttdoc">Used to signal an event. </div></div>
<div class="ttc" id="classflair_1_1meta_1_1_meta_dual_shock3_html"><div class="ttname"><a href="classflair_1_1meta_1_1_meta_dual_shock3.html">flair::meta::MetaDualShock3</a></div><div class="ttdoc">Classe intégrant la manette MetaDualShock3. </div><div class="ttdef"><b>Definition:</b> MetaDualShock3.h:38</div></div>
<div class="ttc" id="classflair_1_1meta_1_1_uav_state_machine_html_a8074514837d84114b8b4e2a6e1d7da86afda22026db89cdc5e88b262ad9424b41"><div class="ttname"><a href="classflair_1_1meta_1_1_uav_state_machine.html#a8074514837d84114b8b4e2a6e1d7da86afda22026db89cdc5e88b262ad9424b41">flair::meta::UavStateMachine::AltitudeState_t::Stabilized</a></div></div>
<div class="ttc" id="classflair_1_1core_1_1_i_o_device_html"><div class="ttname"><a href="classflair_1_1core_1_1_i_o_device.html">flair::core::IODevice</a></div><div class="ttdoc">Abstract class for input/ouput system. </div><div class="ttdef"><b>Definition:</b> IODevice.h:45</div></div>
<div class="ttc" id="classflair_1_1meta_1_1_uav_state_machine_html_a8074514837d84114b8b4e2a6e1d7da86a0912358d703c9a28d93a2707b86161b2"><div class="ttname"><a href="classflair_1_1meta_1_1_uav_state_machine.html#a8074514837d84114b8b4e2a6e1d7da86a0912358d703c9a28d93a2707b86161b2">flair::meta::UavStateMachine::AltitudeState_t::FinishLanding</a></div></div>
<div class="ttc" id="namespaceflair_html"><div class="ttname"><a href="namespaceflair.html">flair</a></div><div class="ttdoc">namespace of the flair Framework </div><div class="ttdef"><b>Definition:</b> Ahrs.h:19</div></div>
<div class="ttc" id="classflair_1_1core_1_1_vector3_d_html"><div class="ttname"><a href="classflair_1_1core_1_1_vector3_d.html">flair::core::Vector3D&lt; float &gt;</a></div></div>
<div class="ttc" id="classflair_1_1core_1_1_euler_html"><div class="ttname"><a href="classflair_1_1core_1_1_euler.html">flair::core::Euler</a></div><div class="ttdoc">Class defining euler angles. </div><div class="ttdef"><b>Definition:</b> Euler.h:27</div></div>
<div class="ttc" id="classflair_1_1meta_1_1_uav_state_machine_html_a8074514837d84114b8b4e2a6e1d7da86a0a0480d215decaf46260e3db52e4dc4c"><div class="ttname"><a href="classflair_1_1meta_1_1_uav_state_machine.html#a8074514837d84114b8b4e2a6e1d7da86a0a0480d215decaf46260e3db52e4dc4c">flair::meta::UavStateMachine::AltitudeState_t::StartLanding</a></div></div>
<div class="ttc" id="classflair_1_1meta_1_1_uav_state_machine_html_ab25472bbf51a7baf97ec5e9cfc148f8b"><div class="ttname"><a href="classflair_1_1meta_1_1_uav_state_machine.html#ab25472bbf51a7baf97ec5e9cfc148f8b">flair::meta::UavStateMachine::ComputeDefaultThrust</a></div><div class="ttdeci">float ComputeDefaultThrust(void)</div><div class="ttdoc">Compute Default Thrust. </div></div>
<div class="ttc" id="_vector2_d_8h_html"><div class="ttname"><a href="_vector2_d_8h.html">Vector2D.h</a></div><div class="ttdoc">Class defining a 2D vector. </div></div>
<div class="ttc" id="classflair_1_1gui_1_1_grid_layout_html"><div class="ttname"><a href="classflair_1_1gui_1_1_grid_layout.html">flair::gui::GridLayout</a></div><div class="ttdoc">Class displaying a QGridLayout on the ground station. </div><div class="ttdef"><b>Definition:</b> GridLayout.h:27</div></div>
<div class="ttc" id="classflair_1_1filter_1_1_pid_thrust_html"><div class="ttname"><a href="classflair_1_1filter_1_1_pid_thrust.html">flair::filter::PidThrust</a></div><div class="ttdoc">Class defining a Pid for Thrust. This Pid as an extra offset for compensating gravity. </div><div class="ttdef"><b>Definition:</b> PidThrust.h:33</div></div>
<div class="ttc" id="classflair_1_1core_1_1_ahrs_data_html"><div class="ttname"><a href="classflair_1_1core_1_1_ahrs_data.html">flair::core::AhrsData</a></div><div class="ttdoc">Class defining AHRS datas. </div><div class="ttdef"><b>Definition:</b> AhrsData.h:30</div></div>
<div class="ttc" id="_vector3_d_8h_html"><div class="ttname"><a href="_vector3_d_8h.html">Vector3D.h</a></div><div class="ttdoc">Class defining a 3D vector. </div></div>
<div class="ttc" id="classflair_1_1meta_1_1_uav_state_machine_html"><div class="ttname"><a href="classflair_1_1meta_1_1_uav_state_machine.html">flair::meta::UavStateMachine</a></div><div class="ttdoc">State machine for UAV The Thread is created with the FrameworkManager as parent. FrameworkManager mus...</div><div class="ttdef"><b>Definition:</b> UavStateMachine.h:67</div></div>
<div class="ttc" id="classflair_1_1sensor_1_1_target_controller_html"><div class="ttname"><a href="classflair_1_1sensor_1_1_target_controller.html">flair::sensor::TargetController</a></div><div class="ttdoc">Base Class for target side remote controls. </div><div class="ttdef"><b>Definition:</b> TargetController.h:49</div></div>
<div class="ttc" id="classflair_1_1meta_1_1_uav_state_machine_html_a8074514837d84114b8b4e2a6e1d7da86a85916c5f3400cfa25d988f05b6736a94"><div class="ttname"><a href="classflair_1_1meta_1_1_uav_state_machine.html#a8074514837d84114b8b4e2a6e1d7da86a85916c5f3400cfa25d988f05b6736a94">flair::meta::UavStateMachine::AltitudeState_t::TakingOff</a></div></div>
<div class="ttc" id="classflair_1_1filter_1_1_trajectory_generator1_d_html"><div class="ttname"><a href="classflair_1_1filter_1_1_trajectory_generator1_d.html">flair::filter::TrajectoryGenerator1D</a></div><div class="ttdoc">Class generating a trajectory in 1D. </div><div class="ttdef"><b>Definition:</b> TrajectoryGenerator1D.h:47</div></div>
<div class="ttc" id="classflair_1_1meta_1_1_uav_state_machine_html_a6af7f575d90ef500717a999ea4c4afef"><div class="ttname"><a href="classflair_1_1meta_1_1_uav_state_machine.html#a6af7f575d90ef500717a999ea4c4afef">flair::meta::UavStateMachine::ComputeCustomThrust</a></div><div class="ttdeci">virtual float ComputeCustomThrust(void)</div><div class="ttdoc">Get Torques. </div></div>
<div class="ttc" id="classflair_1_1meta_1_1_uav_state_machine_html_ab737f2861d5c1901a0f62f54fe2c0855"><div class="ttname"><a href="classflair_1_1meta_1_1_uav_state_machine.html#ab737f2861d5c1901a0f62f54fe2c0855">flair::meta::UavStateMachine::AddDeviceToControlLawLog</a></div><div class="ttdeci">void AddDeviceToControlLawLog(const core::IODevice *device)</div><div class="ttdoc">Get Thrust. </div></div>
<div class="ttc" id="classflair_1_1gui_1_1_push_button_html"><div class="ttname"><a href="classflair_1_1gui_1_1_push_button.html">flair::gui::PushButton</a></div><div class="ttdoc">Class displaying a QPushButton on the ground station. </div><div class="ttdef"><b>Definition:</b> PushButton.h:28</div></div>
<div class="ttc" id="classflair_1_1meta_1_1_uav_state_machine_html_a8074514837d84114b8b4e2a6e1d7da86ac23e2b09ebe6bf4cb5e2a9abe85c0be2"><div class="ttname"><a href="classflair_1_1meta_1_1_uav_state_machine.html#a8074514837d84114b8b4e2a6e1d7da86ac23e2b09ebe6bf4cb5e2a9abe85c0be2">flair::meta::UavStateMachine::AltitudeState_t::Stopped</a></div></div>
<div class="ttc" id="classflair_1_1meta_1_1_uav_state_machine_html_a239d9f75ff1a46752c2b06c37726336a"><div class="ttname"><a href="classflair_1_1meta_1_1_uav_state_machine.html#a239d9f75ff1a46752c2b06c37726336a">flair::meta::UavStateMachine::ComputeCustomTorques</a></div><div class="ttdeci">virtual void ComputeCustomTorques(core::Euler &amp;torques)</div><div class="ttdoc">Compute Custom Torques. </div></div>
<div class="ttc" id="classflair_1_1filter_1_1_pid_html"><div class="ttname"><a href="classflair_1_1filter_1_1_pid.html">flair::filter::Pid</a></div><div class="ttdoc">Class defining a PID. </div><div class="ttdef"><b>Definition:</b> Pid.h:32</div></div>
<div class="ttc" id="_thread_8h_html"><div class="ttname"><a href="_thread_8h.html">Thread.h</a></div><div class="ttdoc">Abstract class for a thread. </div></div>
<div class="ttc" id="_quaternion_8h_html"><div class="ttname"><a href="_quaternion_8h.html">Quaternion.h</a></div><div class="ttdoc">Class defining a quaternion. </div></div>
<div class="ttc" id="classflair_1_1filter_1_1_nested_sat_html"><div class="ttname"><a href="classflair_1_1filter_1_1_nested_sat.html">flair::filter::NestedSat</a></div><div class="ttdoc">Class defining a PID with saturations. </div><div class="ttdef"><b>Definition:</b> NestedSat.h:43</div></div>
<div class="ttc" id="classflair_1_1core_1_1_thread_html"><div class="ttname"><a href="classflair_1_1core_1_1_thread.html">flair::core::Thread</a></div><div class="ttdoc">Abstract class for a thread. </div><div class="ttdef"><b>Definition:</b> Thread.h:38</div></div>
<div class="ttc" id="classflair_1_1gui_1_1_double_spin_box_html"><div class="ttname"><a href="classflair_1_1gui_1_1_double_spin_box.html">flair::gui::DoubleSpinBox</a></div><div class="ttdoc">Class displaying a QDoubleSpinBox on the ground station. </div><div class="ttdef"><b>Definition:</b> DoubleSpinBox.h:28</div></div>
<div class="ttc" id="classflair_1_1meta_1_1_uav_html"><div class="ttname"><a href="classflair_1_1meta_1_1_uav.html">flair::meta::Uav</a></div><div class="ttdoc">Base class to construct sensors/actuators depending on uav type. The Object is created with the Frame...</div><div class="ttdef"><b>Definition:</b> Uav.h:48</div></div>
<div class="ttc" id="classflair_1_1meta_1_1_uav_state_machine_html_aa642bfeb1d97dec839088e2256a3699b"><div class="ttname"><a href="classflair_1_1meta_1_1_uav_state_machine.html#aa642bfeb1d97dec839088e2256a3699b">flair::meta::UavStateMachine::AddDataToControlLawLog</a></div><div class="ttdeci">void AddDataToControlLawLog(const core::io_data *data)</div><div class="ttdoc">Add an io_data to the control law logs. </div></div>
<div class="ttc" id="classflair_1_1meta_1_1_uav_state_machine_html_ac93d0d595a86a014c27375c973f693a8"><div class="ttname"><a href="classflair_1_1meta_1_1_uav_state_machine.html#ac93d0d595a86a014c27375c973f693a8">flair::meta::UavStateMachine::ComputeDefaultTorques</a></div><div class="ttdeci">void ComputeDefaultTorques(core::Euler &amp;torques)</div><div class="ttdoc">Compute Default Torques. </div></div>
<div class="ttc" id="classflair_1_1core_1_1_quaternion_html"><div class="ttname"><a href="classflair_1_1core_1_1_quaternion.html">flair::core::Quaternion</a></div><div class="ttdoc">Class defining a quaternion. </div><div class="ttdef"><b>Definition:</b> Quaternion.h:26</div></div>
<div class="ttc" id="classflair_1_1gui_1_1_tab_html"><div class="ttname"><a href="classflair_1_1gui_1_1_tab.html">flair::gui::Tab</a></div><div class="ttdoc">Class displaying a QTab on the ground station. </div><div class="ttdef"><b>Definition:</b> Tab.h:29</div></div>
<div class="ttc" id="_euler_8h_html"><div class="ttname"><a href="_euler_8h.html">Euler.h</a></div><div class="ttdoc">Class defining euler angles. </div></div>
</div><!-- fragment --></div><!-- contents -->
</div><!-- doc-content -->
<!-- start footer part -->
<div id="nav-path" class="navpath"><!-- id is needed for treeview function! -->
  <ul>
    <li class="navelem"><a class="el" href="dir_33c2ee9b1665499374b4225c427cf176.html">igep</a></li><li class="navelem"><a class="el" href="dir_f1fe274389177bd7e17de7949c4ffada.html">flair-src</a></li><li class="navelem"><a class="el" href="dir_3ef62148cf94871b4b6ee5d6e3a989c1.html">lib</a></li><li class="navelem"><a class="el" href="dir_e44722efdb10e7ceda2dbbaecca58ed3.html">FlairMeta</a></li><li class="navelem"><a class="el" href="dir_ed462f49eec2f2c269d321a045b86103.html">src</a></li><li class="navelem"><b>UavStateMachine.h</b></li>
    <li class="footer">Generated on Thu Jan 31 2019 12:34:23 for Flair by
    <a href="http://www.doxygen.org/index.html">
    <img class="footer" src="doxygen.png" alt="doxygen"/></a> 1.8.9.1 </li>
  </ul>
</div>
</body>
</html>
